unsigned char crash=0,nocrash=0;
char jump=0,reached_pk=0;
char altitude=0;
char setjump=0;


void movement(void){
	static char angle=0,cantpress=0,jumppause=0;
	static char movedown=0,moveup=0,moveleft=0,moveright=0,precrash=0;
	if(crash==1&&!nocrash) nocrash=5;
	if(precrash) precrash--;
	if((_rowread(ARROWS_ROW)&LEFT_KEY)&&!cantpress&&!altitude&&angle>-3){ // change angle to left
		angle--;
		cantpress=6;} 																											// can't press for 10 frames

	
	if((_rowread(ARROWS_ROW)&RIGHT_KEY)&&!cantpress&&!altitude&&angle<3){ // change angle to right
		angle++;
		cantpress=6;} 																											// can't press for 10 frames

	if(jump>0) angle=0;
	
	if((_rowread(ARROWS_ROW)&SECOND_KEY)&&!altitude&&!crash&&!jumppause){ // begin jump
		jump+=20;
		setjump=1;
		cantpress=6;}
		
	if((_rowread(ARROWS_ROW)&SECOND_KEY)&&!cantpress&&jump&&!crash){ 			// rotate jump
		setjump++;
		cantpress=6;} 																											// can't press for 5 frames

	if(cantpress&&jump&&(_rowread(ARROWS_ROW)&SECOND_KEY)) 								// user is holding down jump
		cantpress++; 																												// prolong how long user can't press
	
	if(jumppause&&!(_rowread(ARROWS_ROW)&SECOND_KEY)) 										// user isn't holding down jump
		jumppause=0; 																												// user can jump

	ion_mod(0,27-angle); 																									// set user as whatever angle

	if(cantpress>0) cantpress--; 																					// decrease time that user can't press

	if(altitude==0&&setjump>1){ 																					// player landed on head..crash
		crash++;
		setjump=0;
		jump=0;}

	if(_rowread(ARROWS_ROW)&UP_KEY&&abs(angle)==3){												// allows player to move up the slow when sideways
		moveup+=1;}
		
	if(jump&&crash) {
		offsety=comp[0].y-20;
		jump=0;
		reached_pk=0;altitude=0;}

	if(_rowread(ARROWS_ROW)&DOWN_KEY) angle=0; 														// down changes angle to 0

	if(angle==-3&&(_rowread(ARROWS_ROW)&LEFT_KEY)) {movedown+=0;moveleft+=2;}	// angle routines
	if(angle==-2) {movedown+=2;moveleft+=2;}
	if(angle==-1) {movedown+=3;moveleft+=2;}
	if(angle==0) {movedown+=4;}
	if(angle==1) {movedown+=3;moveright+=2;}
	if(angle==2) {movedown+=2;moveright+=2;}
	if(angle==3&&(_rowread(ARROWS_ROW)&RIGHT_KEY)) {movedown+=0;moveright+=2;}
	

	if(movedown>3&&!crash){																								// move down
		while(movedown-3>0){
			offsety+=1;movedown-=3;
			ion_mov(0,comp[0].x,comp[0].y+1);}}

	if(moveup>3&&!crash){																									// move up
		while(moveup-3>0){
			offsety-=1;moveup-=3;
			ion_mov(0,comp[0].x,comp[0].y-1);}}

	if(moveleft>3&&!crash){																								// move left
		while(moveleft-3>0){
			offsetx-=1;moveleft-=3;
			ion_mov(0,comp[0].x-1,comp[0].y);}}

	if(moveright>3&&!crash){																							// move right
		while(moveright-3>0){
			offsetx+=1;moveright-=3;
			ion_mov(0,comp[0].x+1,comp[0].y);}}

	if(altitude<jump&&!reached_pk&&!crash){																// jump management
		ion_mov(0,comp[0].x,comp[0].y-2);
		altitude+=2;
		if(altitude>=jump) reached_pk++;}
	if(reached_pk&&!crash){
		ion_mov(0,comp[0].x,comp[0].y+1);
		altitude--;
		if(altitude==0) {reached_pk=0;jump=0;}}
	if(jump&&!crash){
		if(setjump==4) setjump=0;
		ion_mod(0,setjump+32);
		if(setjump==0) ion_mod(0,27);}

	if(crash) {																														// crash management, animation, etc.
		if(crash<=25) ion_mod(0,31);
		if(crash>25) ion_mod(0,32);
		crash++;
		if(crash>=50) {
			ion_mod(0,27);
			crash=0;angle=0;movedown=0;moveleft=0;moveright=0;moveup=0;
			offsety+=5;
			ion_mov(0,comp[0].x,comp[0].y+5);}}
}
